/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/BodyHolder.h"
#include "qpid/framing/AMQHeaderBody.h"
#include "qpid/framing/AMQContentBody.h"
#include "qpid/framing/AMQHeartbeatBody.h"
#include "qpid/framing/ConnectionStartBody.h"
#include "qpid/framing/ConnectionStartOkBody.h"
#include "qpid/framing/ConnectionSecureBody.h"
#include "qpid/framing/ConnectionSecureOkBody.h"
#include "qpid/framing/ConnectionTuneBody.h"
#include "qpid/framing/ConnectionTuneOkBody.h"
#include "qpid/framing/ConnectionOpenBody.h"
#include "qpid/framing/ConnectionOpenOkBody.h"
#include "qpid/framing/ConnectionRedirectBody.h"
#include "qpid/framing/ConnectionHeartbeatBody.h"
#include "qpid/framing/ConnectionCloseBody.h"
#include "qpid/framing/ConnectionCloseOkBody.h"
#include "qpid/framing/SessionAttachBody.h"
#include "qpid/framing/SessionAttachedBody.h"
#include "qpid/framing/SessionDetachBody.h"
#include "qpid/framing/SessionDetachedBody.h"
#include "qpid/framing/SessionRequestTimeoutBody.h"
#include "qpid/framing/SessionTimeoutBody.h"
#include "qpid/framing/SessionCommandPointBody.h"
#include "qpid/framing/SessionExpectedBody.h"
#include "qpid/framing/SessionConfirmedBody.h"
#include "qpid/framing/SessionCompletedBody.h"
#include "qpid/framing/SessionKnownCompletedBody.h"
#include "qpid/framing/SessionFlushBody.h"
#include "qpid/framing/SessionGapBody.h"
#include "qpid/framing/ExecutionSyncBody.h"
#include "qpid/framing/ExecutionResultBody.h"
#include "qpid/framing/ExecutionExceptionBody.h"
#include "qpid/framing/MessageTransferBody.h"
#include "qpid/framing/MessageAcceptBody.h"
#include "qpid/framing/MessageRejectBody.h"
#include "qpid/framing/MessageReleaseBody.h"
#include "qpid/framing/MessageAcquireBody.h"
#include "qpid/framing/MessageResumeBody.h"
#include "qpid/framing/MessageSubscribeBody.h"
#include "qpid/framing/MessageCancelBody.h"
#include "qpid/framing/MessageSetFlowModeBody.h"
#include "qpid/framing/MessageFlowBody.h"
#include "qpid/framing/MessageFlushBody.h"
#include "qpid/framing/MessageStopBody.h"
#include "qpid/framing/TxSelectBody.h"
#include "qpid/framing/TxCommitBody.h"
#include "qpid/framing/TxRollbackBody.h"
#include "qpid/framing/DtxSelectBody.h"
#include "qpid/framing/DtxStartBody.h"
#include "qpid/framing/DtxEndBody.h"
#include "qpid/framing/DtxCommitBody.h"
#include "qpid/framing/DtxForgetBody.h"
#include "qpid/framing/DtxGetTimeoutBody.h"
#include "qpid/framing/DtxPrepareBody.h"
#include "qpid/framing/DtxRecoverBody.h"
#include "qpid/framing/DtxRollbackBody.h"
#include "qpid/framing/DtxSetTimeoutBody.h"
#include "qpid/framing/ExchangeDeclareBody.h"
#include "qpid/framing/ExchangeDeleteBody.h"
#include "qpid/framing/ExchangeQueryBody.h"
#include "qpid/framing/ExchangeBindBody.h"
#include "qpid/framing/ExchangeUnbindBody.h"
#include "qpid/framing/ExchangeBoundBody.h"
#include "qpid/framing/QueueDeclareBody.h"
#include "qpid/framing/QueueDeleteBody.h"
#include "qpid/framing/QueuePurgeBody.h"
#include "qpid/framing/QueueQueryBody.h"
#include "qpid/framing/FileQosBody.h"
#include "qpid/framing/FileQosOkBody.h"
#include "qpid/framing/FileConsumeBody.h"
#include "qpid/framing/FileConsumeOkBody.h"
#include "qpid/framing/FileCancelBody.h"
#include "qpid/framing/FileOpenBody.h"
#include "qpid/framing/FileOpenOkBody.h"
#include "qpid/framing/FileStageBody.h"
#include "qpid/framing/FilePublishBody.h"
#include "qpid/framing/FileReturnBody.h"
#include "qpid/framing/FileDeliverBody.h"
#include "qpid/framing/FileAckBody.h"
#include "qpid/framing/FileRejectBody.h"
#include "qpid/framing/StreamQosBody.h"
#include "qpid/framing/StreamQosOkBody.h"
#include "qpid/framing/StreamConsumeBody.h"
#include "qpid/framing/StreamConsumeOkBody.h"
#include "qpid/framing/StreamCancelBody.h"
#include "qpid/framing/StreamPublishBody.h"
#include "qpid/framing/StreamReturnBody.h"
#include "qpid/framing/StreamDeliverBody.h"
#include "qpid/framing/FrameDefaultVisitor.h"
#include "qpid/Exception.h"


namespace qpid {
namespace framing {

void BodyHolder::setMethod(ClassId c, MethodId m) {
    switch (c) {
        case 0x1: switch(m) {
            case 0x1: blob = in_place<ConnectionStartBody>(); break;
            case 0x2: blob = in_place<ConnectionStartOkBody>(); break;
            case 0x3: blob = in_place<ConnectionSecureBody>(); break;
            case 0x4: blob = in_place<ConnectionSecureOkBody>(); break;
            case 0x5: blob = in_place<ConnectionTuneBody>(); break;
            case 0x6: blob = in_place<ConnectionTuneOkBody>(); break;
            case 0x7: blob = in_place<ConnectionOpenBody>(); break;
            case 0x8: blob = in_place<ConnectionOpenOkBody>(); break;
            case 0x9: blob = in_place<ConnectionRedirectBody>(); break;
            case 0xa: blob = in_place<ConnectionHeartbeatBody>(); break;
            case 0xb: blob = in_place<ConnectionCloseBody>(); break;
            case 0xc: blob = in_place<ConnectionCloseOkBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class connection "));
        }
        break;
        case 0x2: switch(m) {
            case 0x1: blob = in_place<SessionAttachBody>(); break;
            case 0x2: blob = in_place<SessionAttachedBody>(); break;
            case 0x3: blob = in_place<SessionDetachBody>(); break;
            case 0x4: blob = in_place<SessionDetachedBody>(); break;
            case 0x5: blob = in_place<SessionRequestTimeoutBody>(); break;
            case 0x6: blob = in_place<SessionTimeoutBody>(); break;
            case 0x7: blob = in_place<SessionCommandPointBody>(); break;
            case 0x8: blob = in_place<SessionExpectedBody>(); break;
            case 0x9: blob = in_place<SessionConfirmedBody>(); break;
            case 0xa: blob = in_place<SessionCompletedBody>(); break;
            case 0xb: blob = in_place<SessionKnownCompletedBody>(); break;
            case 0xc: blob = in_place<SessionFlushBody>(); break;
            case 0xd: blob = in_place<SessionGapBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class session "));
        }
        break;
        case 0x3: switch(m) {
            case 0x1: blob = in_place<ExecutionSyncBody>(); break;
            case 0x2: blob = in_place<ExecutionResultBody>(); break;
            case 0x3: blob = in_place<ExecutionExceptionBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class execution "));
        }
        break;
        case 0x4: switch(m) {
            case 0x1: blob = in_place<MessageTransferBody>(); break;
            case 0x2: blob = in_place<MessageAcceptBody>(); break;
            case 0x3: blob = in_place<MessageRejectBody>(); break;
            case 0x4: blob = in_place<MessageReleaseBody>(); break;
            case 0x5: blob = in_place<MessageAcquireBody>(); break;
            case 0x6: blob = in_place<MessageResumeBody>(); break;
            case 0x7: blob = in_place<MessageSubscribeBody>(); break;
            case 0x8: blob = in_place<MessageCancelBody>(); break;
            case 0x9: blob = in_place<MessageSetFlowModeBody>(); break;
            case 0xa: blob = in_place<MessageFlowBody>(); break;
            case 0xb: blob = in_place<MessageFlushBody>(); break;
            case 0xc: blob = in_place<MessageStopBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class message "));
        }
        break;
        case 0x5: switch(m) {
            case 0x1: blob = in_place<TxSelectBody>(); break;
            case 0x2: blob = in_place<TxCommitBody>(); break;
            case 0x3: blob = in_place<TxRollbackBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class tx "));
        }
        break;
        case 0x6: switch(m) {
            case 0x1: blob = in_place<DtxSelectBody>(); break;
            case 0x2: blob = in_place<DtxStartBody>(); break;
            case 0x3: blob = in_place<DtxEndBody>(); break;
            case 0x4: blob = in_place<DtxCommitBody>(); break;
            case 0x5: blob = in_place<DtxForgetBody>(); break;
            case 0x6: blob = in_place<DtxGetTimeoutBody>(); break;
            case 0x7: blob = in_place<DtxPrepareBody>(); break;
            case 0x8: blob = in_place<DtxRecoverBody>(); break;
            case 0x9: blob = in_place<DtxRollbackBody>(); break;
            case 0xa: blob = in_place<DtxSetTimeoutBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class dtx "));
        }
        break;
        case 0x7: switch(m) {
            case 0x1: blob = in_place<ExchangeDeclareBody>(); break;
            case 0x2: blob = in_place<ExchangeDeleteBody>(); break;
            case 0x3: blob = in_place<ExchangeQueryBody>(); break;
            case 0x4: blob = in_place<ExchangeBindBody>(); break;
            case 0x5: blob = in_place<ExchangeUnbindBody>(); break;
            case 0x6: blob = in_place<ExchangeBoundBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class exchange "));
        }
        break;
        case 0x8: switch(m) {
            case 0x1: blob = in_place<QueueDeclareBody>(); break;
            case 0x2: blob = in_place<QueueDeleteBody>(); break;
            case 0x3: blob = in_place<QueuePurgeBody>(); break;
            case 0x4: blob = in_place<QueueQueryBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class queue "));
        }
        break;
        case 0x9: switch(m) {
            case 0x1: blob = in_place<FileQosBody>(); break;
            case 0x2: blob = in_place<FileQosOkBody>(); break;
            case 0x3: blob = in_place<FileConsumeBody>(); break;
            case 0x4: blob = in_place<FileConsumeOkBody>(); break;
            case 0x5: blob = in_place<FileCancelBody>(); break;
            case 0x6: blob = in_place<FileOpenBody>(); break;
            case 0x7: blob = in_place<FileOpenOkBody>(); break;
            case 0x8: blob = in_place<FileStageBody>(); break;
            case 0x9: blob = in_place<FilePublishBody>(); break;
            case 0xa: blob = in_place<FileReturnBody>(); break;
            case 0xb: blob = in_place<FileDeliverBody>(); break;
            case 0xc: blob = in_place<FileAckBody>(); break;
            case 0xd: blob = in_place<FileRejectBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class file "));
        }
        break;
        case 0xa: switch(m) {
            case 0x1: blob = in_place<StreamQosBody>(); break;
            case 0x2: blob = in_place<StreamQosOkBody>(); break;
            case 0x3: blob = in_place<StreamConsumeBody>(); break;
            case 0x4: blob = in_place<StreamConsumeOkBody>(); break;
            case 0x5: blob = in_place<StreamCancelBody>(); break;
            case 0x6: blob = in_place<StreamPublishBody>(); break;
            case 0x7: blob = in_place<StreamReturnBody>(); break;
            case 0x8: blob = in_place<StreamDeliverBody>(); break;
            default: throw Exception(QPID_MSG("Invalid method id " << int(m) << " for class stream "));
        }
        break;
        default: throw Exception(QPID_MSG("Invalid class id " << int(c)));
    }
}
struct CopyVisitor:
    public FrameDefaultVisitor
{
    using FrameDefaultVisitor::visit;
    using FrameDefaultVisitor::defaultVisit;
    BodyHolder& holder;
    CopyVisitor(BodyHolder& h) : holder(h) {}
    void visit(const AMQHeaderBody& x) { holder=x; }
    void visit(const AMQContentBody& x) { holder=x; }
    void visit(const AMQHeartbeatBody& x) { holder=x; }
    void visit(const ConnectionStartBody& x) { holder=x; }
    void visit(const ConnectionStartOkBody& x) { holder=x; }
    void visit(const ConnectionSecureBody& x) { holder=x; }
    void visit(const ConnectionSecureOkBody& x) { holder=x; }
    void visit(const ConnectionTuneBody& x) { holder=x; }
    void visit(const ConnectionTuneOkBody& x) { holder=x; }
    void visit(const ConnectionOpenBody& x) { holder=x; }
    void visit(const ConnectionOpenOkBody& x) { holder=x; }
    void visit(const ConnectionRedirectBody& x) { holder=x; }
    void visit(const ConnectionHeartbeatBody& x) { holder=x; }
    void visit(const ConnectionCloseBody& x) { holder=x; }
    void visit(const ConnectionCloseOkBody& x) { holder=x; }
    void visit(const SessionAttachBody& x) { holder=x; }
    void visit(const SessionAttachedBody& x) { holder=x; }
    void visit(const SessionDetachBody& x) { holder=x; }
    void visit(const SessionDetachedBody& x) { holder=x; }
    void visit(const SessionRequestTimeoutBody& x) { holder=x; }
    void visit(const SessionTimeoutBody& x) { holder=x; }
    void visit(const SessionCommandPointBody& x) { holder=x; }
    void visit(const SessionExpectedBody& x) { holder=x; }
    void visit(const SessionConfirmedBody& x) { holder=x; }
    void visit(const SessionCompletedBody& x) { holder=x; }
    void visit(const SessionKnownCompletedBody& x) { holder=x; }
    void visit(const SessionFlushBody& x) { holder=x; }
    void visit(const SessionGapBody& x) { holder=x; }
    void visit(const ExecutionSyncBody& x) { holder=x; }
    void visit(const ExecutionResultBody& x) { holder=x; }
    void visit(const ExecutionExceptionBody& x) { holder=x; }
    void visit(const MessageTransferBody& x) { holder=x; }
    void visit(const MessageAcceptBody& x) { holder=x; }
    void visit(const MessageRejectBody& x) { holder=x; }
    void visit(const MessageReleaseBody& x) { holder=x; }
    void visit(const MessageAcquireBody& x) { holder=x; }
    void visit(const MessageResumeBody& x) { holder=x; }
    void visit(const MessageSubscribeBody& x) { holder=x; }
    void visit(const MessageCancelBody& x) { holder=x; }
    void visit(const MessageSetFlowModeBody& x) { holder=x; }
    void visit(const MessageFlowBody& x) { holder=x; }
    void visit(const MessageFlushBody& x) { holder=x; }
    void visit(const MessageStopBody& x) { holder=x; }
    void visit(const TxSelectBody& x) { holder=x; }
    void visit(const TxCommitBody& x) { holder=x; }
    void visit(const TxRollbackBody& x) { holder=x; }
    void visit(const DtxSelectBody& x) { holder=x; }
    void visit(const DtxStartBody& x) { holder=x; }
    void visit(const DtxEndBody& x) { holder=x; }
    void visit(const DtxCommitBody& x) { holder=x; }
    void visit(const DtxForgetBody& x) { holder=x; }
    void visit(const DtxGetTimeoutBody& x) { holder=x; }
    void visit(const DtxPrepareBody& x) { holder=x; }
    void visit(const DtxRecoverBody& x) { holder=x; }
    void visit(const DtxRollbackBody& x) { holder=x; }
    void visit(const DtxSetTimeoutBody& x) { holder=x; }
    void visit(const ExchangeDeclareBody& x) { holder=x; }
    void visit(const ExchangeDeleteBody& x) { holder=x; }
    void visit(const ExchangeQueryBody& x) { holder=x; }
    void visit(const ExchangeBindBody& x) { holder=x; }
    void visit(const ExchangeUnbindBody& x) { holder=x; }
    void visit(const ExchangeBoundBody& x) { holder=x; }
    void visit(const QueueDeclareBody& x) { holder=x; }
    void visit(const QueueDeleteBody& x) { holder=x; }
    void visit(const QueuePurgeBody& x) { holder=x; }
    void visit(const QueueQueryBody& x) { holder=x; }
    void visit(const FileQosBody& x) { holder=x; }
    void visit(const FileQosOkBody& x) { holder=x; }
    void visit(const FileConsumeBody& x) { holder=x; }
    void visit(const FileConsumeOkBody& x) { holder=x; }
    void visit(const FileCancelBody& x) { holder=x; }
    void visit(const FileOpenBody& x) { holder=x; }
    void visit(const FileOpenOkBody& x) { holder=x; }
    void visit(const FileStageBody& x) { holder=x; }
    void visit(const FilePublishBody& x) { holder=x; }
    void visit(const FileReturnBody& x) { holder=x; }
    void visit(const FileDeliverBody& x) { holder=x; }
    void visit(const FileAckBody& x) { holder=x; }
    void visit(const FileRejectBody& x) { holder=x; }
    void visit(const StreamQosBody& x) { holder=x; }
    void visit(const StreamQosOkBody& x) { holder=x; }
    void visit(const StreamConsumeBody& x) { holder=x; }
    void visit(const StreamConsumeOkBody& x) { holder=x; }
    void visit(const StreamCancelBody& x) { holder=x; }
    void visit(const StreamPublishBody& x) { holder=x; }
    void visit(const StreamReturnBody& x) { holder=x; }
    void visit(const StreamDeliverBody& x) { holder=x; }
    void defaultVisit(const AMQBody&) { assert(0); }
};

void BodyHolder::setBody(const AMQBody& b) {
    CopyVisitor cv(*this); b.accept(cv);
}

}} // namespace qpid::framing

