
#ifndef _MANAGEMENT_BRIDGE_
#define _MANAGEMENT_BRIDGE_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"
#include "qpid/sys/AtomicCount.h"

namespace qpid {
namespace management {

class Bridge : public ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];

    // Properties
    uint64_t linkRef;
    uint16_t channelId;
    uint8_t durable;
    std::string src;
    std::string dest;
    std::string key;
    uint8_t srcIsQueue;
    uint8_t srcIsLocal;
    std::string tag;
    std::string excludes;

    // Statistics

    // Private Methods
    static void writeSchema (qpid::framing::Buffer& buf);
    void writeProperties    (qpid::framing::Buffer& buf);
    void writeStatistics    (qpid::framing::Buffer& buf,
                             bool skipHeaders = false);
    void doMethod           (std::string            methodName,
                             qpid::framing::Buffer& inBuf,
                             qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall (void) { return writeSchema; }

    // Stub for getInstChanged.  There are no inst elements
    bool getInstChanged (void) { return false; }

  public:

    friend class PackageQpid;
    typedef boost::shared_ptr<Bridge> shared_ptr;

    Bridge (Manageable* coreObject, Manageable* _parent, uint16_t _channelId, uint8_t _durable, std::string _src, std::string _dest, std::string _key, uint8_t _srcIsQueue, uint8_t _srcIsLocal, std::string _tag, std::string _excludes);
    ~Bridge (void);

    

    std::string getPackageName (void) { return packageName; }
    std::string getClassName   (void) { return className; }
    uint8_t*    getMd5Sum      (void) { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_CLOSE = 1;

    // Accessor Methods

};

}}

#endif  /*!_MANAGEMENT_BRIDGE_*/
