
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "Broker.h"
#include "qpid/management/ArgsBrokerJoinCluster.h"
#include "qpid/management/ArgsBrokerEcho.h"
#include "qpid/management/ArgsBrokerConnect.h"


using namespace qpid::management;
using namespace qpid::sys;
using namespace qpid::framing;
using           std::string;

string  Broker::packageName  = string ("qpid");
string  Broker::className    = string ("broker");
uint8_t Broker::md5Sum[16]   =
    {0x1c,0x67,0x9b,0x35,0x36,0xc,0x1a,0x68,0xb6,0xe7,0x92,0x1e,0xcb,0xf7,0xf1,0xb6};

Broker::Broker (Manageable* _core, Manageable* _parent, uint16_t _port) :
    ManagementObject(_core)
    ,port(_port)
{
    systemRef = _parent->GetManagementObject ()->getObjectId ();

}

Broker::~Broker () {}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string INDEX("index");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Broker::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (11); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (4); // Method Count
    buf.putShort       (0); // Event Count

    // Properties
    ft = FieldTable ();
    ft.setString (NAME,   "systemRef");
    ft.setInt    (TYPE,   TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  1);
    ft.setString (DESC,   "System ID");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "port");
    ft.setInt    (TYPE,   TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  1);
    ft.setString (DESC,   "TCP Port for AMQP Service");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "workerThreads");
    ft.setInt    (TYPE,   TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Thread pool size");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "maxConns");
    ft.setInt    (TYPE,   TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Maximum allowed connections");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "connBacklog");
    ft.setInt    (TYPE,   TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Connection backlog limit for listening socket");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "stagingThreshold");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Broker stages messages over this size to disk");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "mgmtPubInterval");
    ft.setInt    (TYPE,   TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RW);
    ft.setInt    (INDEX,  0);
    ft.setString (UNIT,   "second");
    ft.setInt    (MIN,    1);
    ft.setString (DESC,   "Interval for management broadcasts");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "clusterName");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Name of cluster this server is a member of");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "version");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Running software version");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dataDirEnabled");
    ft.setInt    (TYPE,   TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Persistent configuration storage enabled");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dataDir");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Persistent configuration storage location");
    buf.put (ft);


    // Statistics

    // Methods
    ft = FieldTable ();
    ft.setString (NAME,     "joinCluster");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "clusterName");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,     "leaveCluster");
    ft.setInt    (ARGCOUNT, 0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,     "echo");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Request a response to test the path to the management agent");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "sequence");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "IO");
    ft.setString (DEFAULT, "0");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "body");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "IO");
    ft.setString (DEFAULT, "");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,     "connect");
    ft.setInt    (ARGCOUNT, 7);
    ft.setString (DESC,     "Establish a connection to another broker");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "host");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "port");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "useSsl");
    ft.setInt    (TYPE,    TYPE_BOOL);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "durable");
    ft.setInt    (TYPE,    TYPE_BOOL);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "authMechanism");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "username");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,    "password");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);


    // Events

}

void Broker::writeProperties (Buffer& buf)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);
    buf.putLongLong (systemRef);
    buf.putShort (port);
    buf.putShort (workerThreads);
    buf.putShort (maxConns);
    buf.putShort (connBacklog);
    buf.putLong (stagingThreshold);
    buf.putShort (mgmtPubInterval);
    buf.putShortString (clusterName);
    buf.putShortString (version);
    buf.putOctet (dataDirEnabled?1:0);
    buf.putShortString (dataDir);

}

void Broker::writeStatistics (Buffer& buf, bool skipHeaders)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;


    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics

}

void Broker::doMethod (string methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;

    if (methodName == "joinCluster")
    {
        ArgsBrokerJoinCluster ioArgs;
        inBuf.getShortString (ioArgs.i_clusterName);
        status = coreObject->ManagementMethod (METHOD_JOINCLUSTER, ioArgs);
        outBuf.putLong        (status);
        outBuf.putShortString (Manageable::StatusText (status));
        return;
    }

    if (methodName == "leaveCluster")
    {
        ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_LEAVECLUSTER, ioArgs);
        outBuf.putLong        (status);
        outBuf.putShortString (Manageable::StatusText (status));
        return;
    }

    if (methodName == "echo")
    {
        ArgsBrokerEcho ioArgs;
        ioArgs.io_sequence = inBuf.getLong ();
        inBuf.getLongString (ioArgs.io_body);
        status = coreObject->ManagementMethod (METHOD_ECHO, ioArgs);
        outBuf.putLong        (status);
        outBuf.putShortString (Manageable::StatusText (status));
        outBuf.putLong (ioArgs.io_sequence);
        outBuf.putLongString (ioArgs.io_body);
        return;
    }

    if (methodName == "connect")
    {
        ArgsBrokerConnect ioArgs;
        inBuf.getShortString (ioArgs.i_host);
        ioArgs.i_port = inBuf.getLong ();
        ioArgs.i_useSsl = inBuf.getOctet ()==1;
        ioArgs.i_durable = inBuf.getOctet ()==1;
        inBuf.getShortString (ioArgs.i_authMechanism);
        inBuf.getShortString (ioArgs.i_username);
        inBuf.getShortString (ioArgs.i_password);
        status = coreObject->ManagementMethod (METHOD_CONNECT, ioArgs);
        outBuf.putLong        (status);
        outBuf.putShortString (Manageable::StatusText (status));
        return;
    }

    outBuf.putLong        (status);
    outBuf.putShortString (Manageable::StatusText (status));
}

