
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "Queue.h"


using namespace qpid::management;
using namespace qpid::sys;
using namespace qpid::framing;
using           std::string;

string  Queue::packageName  = string ("qpid");
string  Queue::className    = string ("queue");
uint8_t Queue::md5Sum[16]   =
    {0x86,0x1f,0xe1,0x46,0x80,0x5,0xe7,0x84,0x29,0xb4,0x6b,0x13,0xe2,0x48,0x9,0x3e};

Queue::Queue (Manageable* _core, Manageable* _parent, std::string _name, uint8_t _durable, uint8_t _autoDelete, uint8_t _exclusive) :
    ManagementObject(_core)
    ,name(_name),durable(_durable),autoDelete(_autoDelete),exclusive(_exclusive)
{
    vhostRef = _parent->GetManagementObject ()->getObjectId ();
    msgTotalEnqueues = 0;
    msgTotalDequeues = 0;
    msgTxnEnqueues = 0;
    msgTxnDequeues = 0;
    msgPersistEnqueues = 0;
    msgPersistDequeues = 0;
    byteDepth = 0;
    byteTotalEnqueues = 0;
    byteTotalDequeues = 0;
    byteTxnEnqueues = 0;
    byteTxnDequeues = 0;
    bytePersistEnqueues = 0;
    bytePersistDequeues = 0;
    enqueueTxnStarts = 0;
    enqueueTxnCommits = 0;
    enqueueTxnRejects = 0;
    enqueueTxnCount = 0;
    enqueueTxnCountHigh = 0;
    enqueueTxnCountLow  = 0;
    dequeueTxnStarts = 0;
    dequeueTxnCommits = 0;
    dequeueTxnRejects = 0;
    dequeueTxnCount = 0;
    dequeueTxnCountHigh = 0;
    dequeueTxnCountLow  = 0;
    consumerCount = 0;
    consumerCountHigh = 0;
    consumerCountLow  = 0;
    bindingCount = 0;
    bindingCountHigh = 0;
    bindingCountLow  = 0;
    unackedMessages = 0;
    unackedMessagesHigh = 0;
    unackedMessagesLow  = 0;
    messageLatencyCount = 0;
    messageLatencyMin   = -1;
    messageLatencyMax   = 0;
    messageLatencyTotal = 0;

}

Queue::~Queue () {}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string INDEX("index");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Queue::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (6); // Config Element Count
    buf.putShort       (39); // Inst Element Count
    buf.putShort       (1); // Method Count
    buf.putShort       (0); // Event Count

    // Properties
    ft = FieldTable ();
    ft.setString (NAME,   "vhostRef");
    ft.setInt    (TYPE,   TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  1);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "name");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  1);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "durable");
    ft.setInt    (TYPE,   TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "autoDelete");
    ft.setInt    (TYPE,   TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "exclusive");
    ft.setInt    (TYPE,   TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "arguments");
    ft.setInt    (TYPE,   TYPE_FTABLE);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Arguments supplied in queue.declare");
    buf.put (ft);


    // Statistics
    ft = FieldTable ();
    ft.setString (NAME,   "msgTotalEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Total messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgTotalDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Total messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgTxnEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Transactional messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgTxnDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Transactional messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgPersistEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Persistent messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgPersistDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Persistent messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "msgDepth");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Current size of queue in messages");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "byteDepth");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Current size of queue in bytes");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "byteTotalEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Total messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "byteTotalDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Total messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "byteTxnEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Transactional messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "byteTxnDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Transactional messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "bytePersistEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Persistent messages enqueued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "bytePersistDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "octet");
    ft.setString (DESC,   "Persistent messages dequeued");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnStarts");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total enqueue transactions started ");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnCommits");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total enqueue transactions committed");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnRejects");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total enqueue transactions rejected");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending enqueue transactions");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending enqueue transactions (High)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "enqueueTxnCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending enqueue transactions (Low)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnStarts");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total dequeue transactions started");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnCommits");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total dequeue transactions committed");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnRejects");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Total dequeue transactions rejected");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending dequeue transactions");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending dequeue transactions (High)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "dequeueTxnCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "transaction");
    ft.setString (DESC,   "Current pending dequeue transactions (Low)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "consumerCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "consumer");
    ft.setString (DESC,   "Current consumers on queue");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "consumerCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "consumer");
    ft.setString (DESC,   "Current consumers on queue (High)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "consumerCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "consumer");
    ft.setString (DESC,   "Current consumers on queue (Low)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "bindingCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "binding");
    ft.setString (DESC,   "Current bindings");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "bindingCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "binding");
    ft.setString (DESC,   "Current bindings (High)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "bindingCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "binding");
    ft.setString (DESC,   "Current bindings (Low)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "unackedMessages");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Messages consumed but not yet acked");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "unackedMessagesHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Messages consumed but not yet acked (High)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "unackedMessagesLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "message");
    ft.setString (DESC,   "Messages consumed but not yet acked (Low)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "messageLatencySamples");
    ft.setInt    (TYPE,   TYPE_DELTATIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Broker latency through this queue (Samples)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "messageLatencyMin");
    ft.setInt    (TYPE,   TYPE_DELTATIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Broker latency through this queue (Min)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "messageLatencyMax");
    ft.setInt    (TYPE,   TYPE_DELTATIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Broker latency through this queue (Max)");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "messageLatencyAverage");
    ft.setInt    (TYPE,   TYPE_DELTATIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Broker latency through this queue (Average)");
    buf.put (ft);


    // Methods
    ft = FieldTable ();
    ft.setString (NAME,     "purge");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Discard all messages on queue");
    buf.put (ft);


    // Events

}

void Queue::writeProperties (Buffer& buf)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);
    buf.putLongLong (vhostRef);
    buf.putShortString (name);
    buf.putOctet (durable?1:0);
    buf.putOctet (autoDelete?1:0);
    buf.putOctet (exclusive?1:0);
    arguments.encode (buf);

}

void Queue::writeStatistics (Buffer& buf, bool skipHeaders)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;
    byteDepth = (uint32_t) (byteTotalEnqueues - byteTotalDequeues);


    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLongLong (msgTotalEnqueues);
    buf.putLongLong (msgTotalDequeues);
    buf.putLongLong (msgTxnEnqueues);
    buf.putLongLong (msgTxnDequeues);
    buf.putLongLong (msgPersistEnqueues);
    buf.putLongLong (msgPersistDequeues);
    buf.putLong(msgDepth);
    buf.putLong (byteDepth);
    buf.putLongLong (byteTotalEnqueues);
    buf.putLongLong (byteTotalDequeues);
    buf.putLongLong (byteTxnEnqueues);
    buf.putLongLong (byteTxnDequeues);
    buf.putLongLong (bytePersistEnqueues);
    buf.putLongLong (bytePersistDequeues);
    buf.putLongLong (enqueueTxnStarts);
    buf.putLongLong (enqueueTxnCommits);
    buf.putLongLong (enqueueTxnRejects);
    buf.putLong (enqueueTxnCount);
    buf.putLong (enqueueTxnCountHigh);
    buf.putLong (enqueueTxnCountLow);
    buf.putLongLong (dequeueTxnStarts);
    buf.putLongLong (dequeueTxnCommits);
    buf.putLongLong (dequeueTxnRejects);
    buf.putLong (dequeueTxnCount);
    buf.putLong (dequeueTxnCountHigh);
    buf.putLong (dequeueTxnCountLow);
    buf.putLong (consumerCount);
    buf.putLong (consumerCountHigh);
    buf.putLong (consumerCountLow);
    buf.putLong (bindingCount);
    buf.putLong (bindingCountHigh);
    buf.putLong (bindingCountLow);
    buf.putLong (unackedMessages);
    buf.putLong (unackedMessagesHigh);
    buf.putLong (unackedMessagesLow);
    buf.putLongLong (messageLatencyCount);
    buf.putLongLong (messageLatencyCount ? messageLatencyMin : 0);
    buf.putLongLong (messageLatencyMax);
    buf.putLongLong (messageLatencyCount ? messageLatencyTotal / messageLatencyCount : 0);


    // Maintenance of hi-lo statistics
    enqueueTxnCountHigh = enqueueTxnCount;
    enqueueTxnCountLow  = enqueueTxnCount;
    dequeueTxnCountHigh = dequeueTxnCount;
    dequeueTxnCountLow  = dequeueTxnCount;
    consumerCountHigh = consumerCount;
    consumerCountLow  = consumerCount;
    bindingCountHigh = bindingCount;
    bindingCountLow  = bindingCount;
    unackedMessagesHigh = unackedMessages;
    unackedMessagesLow  = unackedMessages;
    messageLatencyCount = 0;
    messageLatencyTotal = 0;
    messageLatencyMin   = -1;
    messageLatencyMax   = 0;

}

void Queue::doMethod (string methodName, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;

    if (methodName == "purge")
    {
        ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_PURGE, ioArgs);
        outBuf.putLong        (status);
        outBuf.putShortString (Manageable::StatusText (status));
        return;
    }

    outBuf.putLong        (status);
    outBuf.putShortString (Manageable::StatusText (status));
}

