
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "System.h"


using namespace qpid::management;
using namespace qpid::sys;
using namespace qpid::framing;
using           std::string;

string  System::packageName  = string ("qpid");
string  System::className    = string ("system");
uint8_t System::md5Sum[16]   =
    {0x92,0xf7,0x52,0x2b,0x18,0x88,0x82,0xd7,0x49,0xea,0x66,0x8d,0xb4,0xc5,0xea,0xb};

System::System (Manageable* _core, framing::Uuid _systemId) :
    ManagementObject(_core)
    ,systemId(_systemId)
{
    

}

System::~System () {}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string INDEX("index");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void System::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (6); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (0); // Method Count
    buf.putShort       (0); // Event Count

    // Properties
    ft = FieldTable ();
    ft.setString (NAME,   "systemId");
    ft.setInt    (TYPE,   TYPE_UUID);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (INDEX,  1);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "osName");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Operating System Name");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "nodeName");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Node Name");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "release");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "version");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "machine");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    buf.put (ft);


    // Statistics

    // Methods

    // Events

}

void System::writeProperties (Buffer& buf)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);
    systemId.encode (buf);
    buf.putShortString (osName);
    buf.putShortString (nodeName);
    buf.putShortString (release);
    buf.putShortString (version);
    buf.putShortString (machine);

}

void System::writeStatistics (Buffer& buf, bool skipHeaders)
{
    sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;


    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics

}

void System::doMethod (string, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;

    outBuf.putLong        (status);
    outBuf.putShortString (Manageable::StatusText (status));
}

